{******************************************************************************}
{                       CnPack For Delphi/C++Builder                           }
{                     йԼĿԴ                         }
{                   (C)Copyright 2001-2019 CnPack                        }
{                   ------------------------------------                       }
{                                                                              }
{            ǿԴ CnPack ķЭ        }
{        ĺ·һ                                                }
{                                                                              }
{            һĿϣãûκεû        }
{        ʺضĿĶĵϸ CnPack Э顣        }
{                                                                              }
{            ӦѾͿһյһ CnPack Эĸ        }
{        ûУɷǵվ                                            }
{                                                                              }
{            վַhttp://www.cnpack.org                                   }
{            ʼmaster@cnpack.org                                       }
{                                                                              }
{******************************************************************************}

unit CnFavoriteWizard;
{ |<PRE>
================================================================================
* ƣCnPack IDE רҰ
* ԪƣղؼרҵԪ
* ԪߣΰAlan BeyondStudio@163.com
*     ע
* ƽ̨PWin2000Pro + Delphi 5.01
* ݲԣPWin9X/2000/XP + Delphi 5/6/7 + C++Builder 5/6
*   ôеֱַ֧ػʽ
* ޸ļ¼2003.07.15 V1.0
*               Ԫ
================================================================================
|</PRE>}

interface

{$I CnWizards.inc}

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs, ToolsAPI,
  IniFiles, CnBaseWizard, CnConsts, CnWizUtils, CnWizConsts, CnAddToFavoriteFrm,
  CnManageFavoriteFrm, CnWizIdeUtils;

type

//==============================================================================
// ղؼר
//==============================================================================

{ TCnFavoriteWizard }

  TCnFavoriteWizard = class(TCnSubMenuWizard)
  private
    IDAddToFavorite: Integer;
    IDManageFavorite: Integer;
  protected
    function GetHasConfig: Boolean; override;
    procedure SubActionExecute(Index: Integer); override;
    procedure SubActionUpdate(Index: Integer); override;
  public
    constructor Create; override;
    function GetState: TWizardState; override;
    procedure Config; override;
    procedure Loaded; override;
    procedure LoadSettings(Ini: TCustomIniFile); override;
    procedure SaveSettings(Ini: TCustomIniFile); override;
    class procedure GetWizardInfo(var Name, Author, Email, Comment: string); override;
    function GetCaption: string; override;
    function GetHint: string; override;
  end;

implementation

{$IFDEF Debug}
uses
  uDbg;
{$ENDIF Debug}

{ TCnFavoriteWizard }

procedure TCnFavoriteWizard.Config;
begin
  ShowShortCutDialog('CnFavoriteWizard');
end;

constructor TCnFavoriteWizard.Create;
begin
  inherited;

  IDAddToFavorite := AddSubAction(SCnFavWizAddToFavorite,
    SCnFavWizAddToFavoriteMenuCaption, 0,
    SCnFavWizAddToFavoriteMenuHint, SCnFavWizAddToFavorite);

  IDManageFavorite := AddSubAction(SCnFavWizManageFavorite,
    SCnFavWizManageFavoriteMenuCaption, 0,
    SCnFavWizManageFavoriteMenuHint, SCnFavWizManageFavorite);

  AddSepMenu;
end;

function TCnFavoriteWizard.GetCaption: string;
begin
  Result := SCnFavWizCaption;
end;

function TCnFavoriteWizard.GetHasConfig: Boolean;
begin
  Result := True;
end;

function TCnFavoriteWizard.GetHint: string;
begin
  Result := SCnFavWizHint;
end;

function TCnFavoriteWizard.GetState: TWizardState;
begin
  Result := [wsEnabled];
end;

class procedure TCnFavoriteWizard.GetWizardInfo(var Name, Author, Email,
  Comment: string);
begin
  Name := SCnFavWizName;
  Author := SCnPack_Alan;
  Email := SCnPack_AlanEmail;
  Comment := SCnFavWizComment;
end;

procedure TCnFavoriteWizard.Loaded;
begin
  inherited;

end;

procedure TCnFavoriteWizard.LoadSettings(Ini: TCustomIniFile);
begin
  inherited;

end;

procedure TCnFavoriteWizard.SaveSettings(Ini: TCustomIniFile);
begin
  inherited;

end;

procedure TCnFavoriteWizard.SubActionExecute(Index: Integer);
begin
  if not Active then Exit;

  if Index = IDAddToFavorite then
    ShowAddToFavoriteForm
  else
  if Index = IDManageFavorite then
    ShowManageFavoriteForm;
end;

procedure TCnFavoriteWizard.SubActionUpdate(Index: Integer);
var
  AEnabled: Boolean;
begin
  AEnabled := (CnOtaGetCurrentFormEditor <> nil) or (CnOtaGetCurrentSourceEditor <> nil);

  SubActions[IDAddToFavorite].Visible := Active;
  SubActions[IDAddToFavorite].Enabled := AEnabled;
end;

initialization
  RegisterCnWizard(TCnFavoriteWizard); // ער

end.
